from abc import ABC, abstractmethod
from typing import Any, Optional, Union

from pydantic import BaseModel

from telefone.api import ABCAPI, API
from telefone.bot.states import StatePeer


class BaseBotUpdate(ABC, BaseModel):
    state_peer: Optional[StatePeer] = None
    unprepared_ctx_api: Optional[Any] = None

    @abstractmethod
    def get_state_key(self) -> Optional[int]:
        pass

    @property
    def ctx_api(self) -> Optional[Union[ABCAPI, API]]:
        return getattr(self, "unprepared_ctx_api")